﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Spire.Pdf;
using Spire.Pdf.Tables;
using Spire.Pdf.Graphics;
using System.Data.OleDb;
using System.Data;
using Spire.Pdf.Security;
using System.Drawing;

namespace signature
{
    public partial class _default : System.Web.UI.Page
    {
        protected void Button1_Click(object sender, EventArgs e)
        {
            PdfDocument doc = new PdfDocument();
            PdfPageBase page = doc.Pages.Add(PdfPageSize.A4);
            float y = 10;
            //create data table
            PdfTable table = new PdfTable();
            table.Style.CellPadding = 2;
            PdfBrush brush1 = PdfBrushes.Black;
            table.Style.BorderPen = new PdfPen(brush1, 0.75f);
            table.Style.DefaultStyle.BackgroundBrush = PdfBrushes.SkyBlue;
            table.Style.DefaultStyle.Font = new PdfTrueTypeFont(new Font("Arial", 10f));
            table.Style.AlternateStyle = new PdfCellStyle();
            table.Style.AlternateStyle.BackgroundBrush = PdfBrushes.LightYellow;
            table.Style.AlternateStyle.Font = new PdfTrueTypeFont(new Font("Arial", 10f));
            table.Style.HeaderSource = PdfHeaderSource.ColumnCaptions;
            table.Style.HeaderStyle.BackgroundBrush = PdfBrushes.CadetBlue;
            table.Style.HeaderStyle.Font = new PdfTrueTypeFont(new Font("Arial", 11f, FontStyle.Bold));
            table.Style.HeaderStyle.StringFormat = new PdfStringFormat(PdfTextAlignment.Center);
            table.Style.ShowHeader = true;

            using (OleDbConnection conn = new OleDbConnection())
            {
                string connectStr= @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source={0}";
                conn.ConnectionString = String.Format(connectStr, Server.MapPath("demo.mdb"));
                OleDbCommand command = new OleDbCommand();
                command.CommandText
                    = " select Name,Capital,Continent,Area,Population from country ";
                command.Connection = conn;
                using (OleDbDataAdapter dataAdapter = new OleDbDataAdapter(command))
                {
                    DataTable dataTable = new DataTable();
                    dataAdapter.Fill(dataTable);
                    table.DataSourceType = PdfTableDataSourceType.TableDirect;
                    table.DataSource = dataTable;
                }
            }
            float width = page.Canvas.ClientSize.Width
                - (table.Columns.Count + 1) * table.Style.BorderPen.Width;
            table.Columns[0].Width = width * 0.24f * width;
            table.Columns[0].StringFormat
                = new PdfStringFormat(PdfTextAlignment.Left, PdfVerticalAlignment.Middle);
            table.Columns[1].Width = width * 0.21f * width;
            table.Columns[1].StringFormat
                = new PdfStringFormat(PdfTextAlignment.Left, PdfVerticalAlignment.Middle);
            table.Columns[2].Width = width * 0.24f * width;
            table.Columns[2].StringFormat
                = new PdfStringFormat(PdfTextAlignment.Left, PdfVerticalAlignment.Middle);
            table.Columns[3].Width = width * 0.13f * width;
            table.Columns[3].StringFormat
                = new PdfStringFormat(PdfTextAlignment.Right, PdfVerticalAlignment.Middle);
            table.Columns[4].Width = width * 0.18f * width;
            table.Columns[4].StringFormat
                = new PdfStringFormat(PdfTextAlignment.Right, PdfVerticalAlignment.Middle);

            PdfLayoutResult result = table.Draw(page, new PointF(30, y));

            y = y + result.Bounds.Height + 10;

            PdfCertificate certificate = new PdfCertificate(Server.MapPath("Demo.pfx"), "e-iceblue");
            //Add a signature
            var signature = new PdfSignature(doc, page, certificate, "requested1");
            signature.Bounds = new RectangleF(new PointF(150, y), new SizeF(260, 90));

            signature.NameLabel= "Digitally signed by";
            signature.Name = "Harry Hu for Tests";
            signature.DistinguishedName = "DN: ";
            signature.LocationInfoLabel = "Location: ";
            signature.LocationInfo = "London";
            signature.ReasonLabel = "Reason: ";
            signature.Reason = "Le document est certifie";
            signature.DateLabel = "Date: ";
            signature.Date = DateTime.Today;
            signature.ContactInfoLabel = "Contact: ";
            signature.ContactInfo = "123456789";
            signature.Certificated = false;
            signature.GraphicsMode = GraphicMode.SignImageAndSignDetail;
            signature.SignImageSource = PdfImage.FromFile(Server.MapPath("logo.gif"));

            signature.DocumentPermissions = PdfCertificationFlags.ForbidChanges;

            doc.SaveToHttpResponse("output.pdf", Response, HttpReadType.Save);

        }
    }
}